<template>
  <div>
    <h2 class="text-h4">2. Add query steps to the pipeline</h2>
    <template v-for="step in steps" :key="step.name">
      <span class="ma-2 d-inline-block">
        <QueryPipelineStep
          v-bind="step"
          :disabled="!selectable(step)"
          @icon-click="select(step)"
        />
      </span>
    </template>
    <v-divider></v-divider>
    <h2 v-if="selectedSteps.length" class="text-h5 mt-4">
      Current pipeline steps
    </h2>
    <template v-for="(step, i) in selectedSteps" :key="i">
      <span class="ma-2 d-inline-block">
        <QueryPipelineStep
          v-bind="step"
          :selected="true"
          :no-action="i < selectedSteps.length - 1"
          @icon-click="unselect(step)"
        />
      </span>
    </template>
  </div>
</template>

<script setup lang="ts">
import type { QueryPipelineStep as Step } from "~/utils/types/querypipeline";
const queryPipeline = inject(queryPipelineKey);
if (queryPipeline === undefined) {
  throw new Error("Cannot inject query pipeline");
}

const { steps, selectedSteps, select, unselect } = queryPipeline;
const availableInputKeys = computed(() => {
  return new Set(
    selectedSteps.value.flatMap(({ input, output }) => [input, output]),
  );
});

const selectable = (step: Step) => {
  if (selectedSteps.value.length === 0) {
    return true;
  }
  if (selectedSteps.value.map((s) => s.name).includes(step.name)) {
    return false;
  }
  return availableInputKeys.value.has(step.input);
};
</script>
